-
Notifications
You must be signed in to change notification settings - Fork 16
/
yBeltAnchor.py
309 lines (272 loc) · 12.9 KB
/
yBeltAnchor.py
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
# Copyright 2015 Matthew Rogge
#
# This file is part of Retr3d.
#
# Retr3d is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Retr3d is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Retr3d. If not, see <http://www.gnu.org/licenses/>.
#import Math stuff
from __future__ import division # allows floating point division from integersimport math
import math
from itertools import product
#import FreeCAD modules
import FreeCAD as App
import FreeCAD# as #
import Part
import Sketcher
import Draft
#Specific to printer
import globalVars as gv
import utilityFunctions as uf
class YBeltAnchor(object):
def __init__(self):
self.name = "yBeltAnchor"
def assemble(self):
App.ActiveDocument=App.getDocument(self.name)
shape = App.ActiveDocument.ActiveObject.Shape
App.ActiveDocument=App.getDocument("PrinterAssembly")
App.ActiveDocument.addObject('Part::Feature',self.name).Shape= shape
#Color Part
#Get the feature and move it into position
objs = App.ActiveDocument.getObjectsByLabel(self.name)
shape = objs[-1]
#Rotate into correct orientation
rotateAngle = 180
rotateCenter = App.Vector(0,0,0)
rotateAxis = App.Vector(1,0,0)
Draft.rotate([shape],rotateAngle,rotateCenter,axis = rotateAxis,copy=False)
#Rotate into correct orientation
rotateAngle = 90
rotateCenter = App.Vector(0,0,0)
rotateAxis = App.Vector(0,0,1)
Draft.rotate([shape],rotateAngle,rotateCenter,axis = rotateAxis,copy=False)
#Define shifts and move the left clamp into place
xShift = gv.yMotorPulleyDia/2
yShift = 0
zShift = gv.PBBHStandoff
App.ActiveDocument=App.getDocument("PrinterAssembly")
Draft.move([shape],App.Vector(xShift, yShift, zShift),copy=False)
App.ActiveDocument.recompute()
if shape not in gv.yAxisParts:
gv.yAxisParts.append(shape)
def draw(self):
#helper Variables
#Find the widest component of the anchor and set the width to that
baseWidth = (gv.printedToPrintedDia+2*gv.mountToPrintedPadding
if gv.printedToPrintedDia+2*gv.mountToPrintedPadding
> gv.yBeltAnchorWidth else gv.yBeltAnchorWidth)
baseLength = (gv.yBeltAnchorLength
+2*gv.printedToPrintedDia
+4*gv.mountToPrintedPadding)
#Make file and build part
try:
App.getDocument("yBeltAnchor").recompute()
App.closeDocument("yBeltAnchor")
App.setActiveDocument("")
App.ActiveDocument=None
except:
pass
#Create Document
App.newDocument("yBeltAnchor")
App.setActiveDocument("yBeltAnchor")
App.ActiveDocument=App.getDocument("yBeltAnchor")
#Make base
#Sketch points
p1x = -baseLength/2
p1y = -baseWidth/2
p2x = -baseLength/2
p2y = baseWidth/2
p3x = baseLength/2
p3y = baseWidth/2
p4x = baseLength/2
p4y = -baseWidth/2
#Make Sketch
App.activeDocument().addObject('Sketcher::SketchObject','Sketch')
App.activeDocument().Sketch.Placement = App.Placement(App.Vector(0.000000,0.000000,0.000000),App.Rotation(0.000000,0.000000,0.000000,1.000000))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p1x,p1y,0),App.Vector(p4x,p4y,0)))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p3x,p3y,0)))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p3x,p3y,0),App.Vector(p2x,p2y,0)))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p2x,p2y,0),App.Vector(p1x,p1y,0)))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',0,2,1,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',2,2,3,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',3,2,0,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Horizontal',0))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Horizontal',2))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Vertical',1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Vertical',3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Symmetric',1,2,0,1,-1,1))
App.ActiveDocument.recompute()
#add dimensions
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('DistanceY',1,baseWidth))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('DistanceX',0,baseLength))
App.ActiveDocument.recompute()
App.getDocument("yBeltAnchor").recompute()
#Pad base
App.activeDocument().addObject("PartDesign::Pad","Pad")
App.activeDocument().Pad.Sketch = App.activeDocument().Sketch
App.activeDocument().Pad.Length = 10.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pad.Length = gv.tabThickness
App.ActiveDocument.Pad.Reversed = 0
App.ActiveDocument.Pad.Midplane = 0
App.ActiveDocument.Pad.Length2 = 100.000000
App.ActiveDocument.Pad.Type = 0
App.ActiveDocument.Pad.UpToFace = None
App.ActiveDocument.recompute()
#Cut hole on right side
#Sketch points
p1x = gv.yBeltAnchorLength/2+gv.mountToPrintedPadding+gv.printedToPrintedDia/2
p1y = 0
#Make sketch
App.activeDocument().addObject('Sketcher::SketchObject','Sketch001')
App.activeDocument().Sketch001.Support = uf.getFace(App.ActiveDocument.Pad,
0,0,
0, 0,
gv.tabThickness, 0)
App.activeDocument().recompute()
App.ActiveDocument.Sketch001.addGeometry(Part.Circle(App.Vector(p1x,p1y,0),App.Vector(0,0,1),gv.printedToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('PointOnObject',0,3,-1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Radius',0,gv.printedToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('DistanceX',-1,1,0,3,p1x))
App.ActiveDocument.recompute()
App.getDocument('yBeltAnchor').recompute()
#Cut hole through all
App.activeDocument().addObject("PartDesign::Pocket","Pocket")
App.activeDocument().Pocket.Sketch = App.activeDocument().Sketch001
App.activeDocument().Pocket.Length = 5.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pocket.Length = 5.000000
App.ActiveDocument.Pocket.Type = 1
App.ActiveDocument.Pocket.UpToFace = None
App.ActiveDocument.recompute()
#Mirror the hole
App.activeDocument().addObject("PartDesign::Mirrored","Mirrored")
App.ActiveDocument.recompute()
App.activeDocument().Mirrored.Originals = [App.activeDocument().Pocket,]
App.activeDocument().Mirrored.MirrorPlane = (App.activeDocument().Sketch001, ["V_Axis"])
#Make the column
#Sketch points
p1x = -gv.yBeltAnchorWidth/2
p1y = -gv.yBeltAnchorLength/2
p2x = -gv.yBeltAnchorWidth/2
p2y = gv.yBeltAnchorLength/2
p3x = gv.yBeltAnchorWidth/2
p3y = gv.yBeltAnchorLength/2
p4x = gv.yBeltAnchorWidth/2
p4y = -gv.yBeltAnchorLength/2
App.activeDocument().addObject('Sketcher::SketchObject','Sketch002')
App.activeDocument().recompute()
App.activeDocument().Sketch002.Support = uf.getFace(App.ActiveDocument.Mirrored,
0,0,
0, 0,
gv.tabThickness, 0)
App.activeDocument().recompute()
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p1x,p1y,0),App.Vector(p4x,p4y,0)))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p3x,p3y,0)))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p3x,p3y,0),App.Vector(p2x,p2y,0)))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p1x,p1y,0)))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',0,2,1,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',2,2,3,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',3,2,0,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Horizontal',0))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Horizontal',2))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Vertical',1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Vertical',3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Symmetric',1,2,0,1,-1,1))
App.ActiveDocument.recompute()
#Add Dimensions
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('DistanceY',1,gv.yBeltAnchorWidth))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('DistanceX',2,-gv.yBeltAnchorLength))
App.ActiveDocument.recompute()
App.getDocument('yBeltAnchor').recompute()
#Extrude column
App.activeDocument().addObject("PartDesign::Pad","Pad001")
App.activeDocument().Pad001.Sketch = App.activeDocument().Sketch002
App.activeDocument().Pad001.Length = 10.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pad001.Length = gv.yBeltAnchorHeight-gv.tabThickness
App.ActiveDocument.Pad001.Reversed = 0
App.ActiveDocument.Pad001.Midplane = 0
App.ActiveDocument.Pad001.Length2 = 100.000000
App.ActiveDocument.Pad001.Type = 0
App.ActiveDocument.Pad001.UpToFace = None
App.ActiveDocument.recompute()
#Cut slot in column
#Sketch Points
p1x = -gv.yBeltAnchorSlotWidth/2
p1y = gv.tabThickness
p2x = -gv.yBeltAnchorSlotWidth/2
p2y = gv.yBeltAnchorHeight-gv.yBeltAnchorBridgeThickness
p3x = gv.yBeltAnchorSlotWidth/2
p3y = gv.yBeltAnchorHeight-gv.yBeltAnchorBridgeThickness
p4x = gv.yBeltAnchorSlotWidth/2
p4y = gv.tabThickness
#Make Sketch
App.activeDocument().addObject('Sketcher::SketchObject','Sketch003')
App.activeDocument().recompute()
App.activeDocument().Sketch003.Support = uf.getFace(App.ActiveDocument.Pad001,
None, None,
-gv.yBeltAnchorWidth/2, 0,
None, None)
App.activeDocument().recompute()
App.ActiveDocument.Sketch003.addExternal("Pad001",uf.getEdge(App.ActiveDocument.Pad001,
0,0,
-gv.yBeltAnchorWidth/2, 0,
gv.tabThickness,0))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch003.addGeometry(Part.Line(App.Vector(p1x,p1y,0),App.Vector(p4x,p4y,0)))
App.ActiveDocument.Sketch003.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p3x,p3y,0)))
App.ActiveDocument.Sketch003.addGeometry(Part.Line(App.Vector(p3x,p3y,0),App.Vector(p2x,p2y,0)))
App.ActiveDocument.Sketch003.addGeometry(Part.Line(App.Vector(p2x,p2y,0),App.Vector(p1x,p1y,0)))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Coincident',0,2,1,1))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Coincident',2,2,3,1))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Coincident',3,2,0,1))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Horizontal',0))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Horizontal',2))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Vertical',1))
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Vertical',3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('PointOnObject',0,1,-3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Symmetric',1,2,2,2,-2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch003.addExternal("Pad001","Edge1")
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('Distance',1,2,-4,gv.yBeltAnchorBridgeThickness))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch003.addConstraint(Sketcher.Constraint('DistanceX',0,gv.yBeltAnchorSlotWidth))
App.ActiveDocument.recompute()
App.getDocument('yBeltAnchor').recompute()
#Cut Slot through all
App.activeDocument().addObject("PartDesign::Pocket","Pocket001")
App.activeDocument().Pocket001.Sketch = App.activeDocument().Sketch003
App.activeDocument().Pocket001.Length = 5.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pocket001.Length = 5.000000
App.ActiveDocument.Pocket001.Type = 1
App.ActiveDocument.Pocket001.UpToFace = None
App.ActiveDocument.recompute()
#Refine Shape
App.ActiveDocument.addObject('Part::Feature','Pocket001').Shape=App.ActiveDocument.Pocket001.Shape.removeSplitter()
App.ActiveDocument.ActiveObject.Label=App.ActiveDocument.Pocket001.Label
App.ActiveDocument.recompute()
#Make view axiometric